/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : master1.c
              Author : S.R.Christian, D. Johnston
   Date first issued : 12-Apr-91



Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
******************************************************************/
/*}}}*/

#include <stdio.h>
#include <stdlib.h>
#include <misc.h>
#include <channel.h>
#include "vme.h"
#include "basic.h"

int main()
{
  Channel *from_slave;
  Channel *to_slave;
  int     i=0;

    from_slave = (Channel *)get_param(3); /* get the channel addresses */
    to_slave   = (Channel *)get_param(4); /* from the cfs file.        */

    basic_board_init();

    i=init_slot_one(ARBITER_PRI,32);
    i=init_vme_master(3,3,0);       /* Bcap mode , writepost off */
                                    /* addr,     size,  D,  A,  LA Mux */
    i=prog_master_access((void *)0x00100000, 0x00100000,32, 32, 0, 0);

    i=turnon_vme_master();

    i = ChanInInt(from_slave);                /* Get stuff from slave     */
    ChanOutInt(to_slave,1);                   /* & send to the slave      */
                                              /* So the boards are synced */
                                              /* & talking to each other. */
    printf ("\n Boards setup & synchronised\n");

    printf ("\n Testing A32,D32");

    i=shadow_read_map_ram((void *)0x00100000);
    printf("\nmapram a32, d32, lad=0 =>%x",i);

    *((int *)0x00100000)=0x01234567;         /* write to the vme bus */
    *((int *)0x00100004)=0x89ABCDEF;         /* write to the vme bus */

    i=*((int *)0x00100000);            /* Read the values back */
    printf("\n(A32, D32) 0x00100000 = %8.8x  should be 1234567",i);

    i=*((int *)0x00100004);
    printf("\n(A32, D32) 0x00100004 = %8.8x  should be 89abcdef\n",i);

    printf ("\n Finished");
    printf ("\n");
    exit_terminate (0);

}
