/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : master2.c
              Author : S.R.Christian, D. Johnston
   Date first issued : 12-Apr-91



Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
******************************************************************/
/*}}}*/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <misc.h>
#include <time.h>
#include <channel.h>
#include "vme.h"
#include "basic.h"
#include "event.h"

void my_int_handler_1(void)
  {
    printf("\n Got Interrupt on irq 1");
  }
void my_int_handler_2(void)
  {
    printf("\n Got interrupt on irq 2");
  }
void my_int_handler_3(void)
  {
    printf("\n Got interrupt on irq 3");
  }
void my_int_handler_4(void)
  {
    printf("\n Got interrupt on irq 4");
  }
void my_int_handler_5(void)
  {
    printf("\n Got interrupt on irq 5");
  }
void my_int_handler_6(void)
  {
    printf("\n Got interrupt on irq 6");
  }
void my_int_handler_7(void)
  {
    printf("\n Got interrupt on irq 7");
  }
void my_int_ack_handler(void)
  {
    printf("\n Got int_ack");
  }

int main()
  {

  Channel *from_slave;
  Channel *to_slave;
  int vec;
  int i;

    from_slave = (Channel *)get_param(3);
    to_slave   = (Channel *)get_param(4);

    basic_board_init();

    init_slot_one(ARBITER_PRI, 32);
    init_vme_master(3,RELMODE_BCAP, NO_WRITEPOST);

    start_event_handler();

    vec=install_vme_int_handler(1,VECTOR_INT_1,my_int_handler_1);
    if (vec==(-1)) {printf("\n Handler 1 didn't work");}
    vec=install_vme_int_handler(2,VECTOR_INT_2,my_int_handler_2);
    if (vec==(-1)) {printf("\n Handler 2 didn't work");}
    vec=install_vme_int_handler(3,VECTOR_INT_3,my_int_handler_3);
    if (vec==(-1)) {printf("\n Handler 3 didn't work");}
    vec=install_vme_int_handler(4,VECTOR_INT_4,my_int_handler_4);
    if (vec==(-1)) {printf("\n Handler 4 didn't work");}
    vec=install_vme_int_handler(5,VECTOR_INT_5,my_int_handler_5);
    if (vec==(-1)) {printf("\n Handler 5 didn't work");}
    vec=install_vme_int_handler(6,VECTOR_INT_6,my_int_handler_6);
    if (vec==(-1)) {printf("\n Handler 6 didn't work");}
    vec=install_vme_int_handler(7,VECTOR_INT_7,my_int_handler_7);
    if (vec==(-1)) {printf("\n Handler 7 didn't work");}

    vec=install_vme_int_ack_handler(my_int_ack_handler);
    if (vec==(-1)) {printf("\n int_ack handler didn't work");}

    prog_vme_interrupt_vector(1,VECTOR_INT_1);  /* setup interrupt vector */
    

    i = ChanInInt(from_slave);                /* slave done setup int vectors */
    ChanOutInt(to_slave,1);                   /* & send to the slave      */
                                              /* So the boards are synced */
                                              /* & talking to each other. */
    printf ("\n Boards setup & synchronised\n");

    send_vme_interrupt(1);
    ProcWait(10000);

    printf("\n Waiting for interrupts");
                              
    i = ChanInInt(from_slave);                /* Slave done sending ints */
    printf ("\n Finished\n");
    exit_terminate (0);

  }
