/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : basic.h
              Author : S.R.Christian, D. Johnston
   Date first issued : 2-Aug-90x

Basic definitions for the IMS B016 hardware

Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
******************************************************************/
/*}}}*/
/*{{{TRUE/FALSE*/
#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif
/*}}}*/

#define MEMORY            0x0

/*{{{vic*/
#define VIC_REGS          0X7FD90000
#define VIC_INT_CONT_ENB  0X7FD90000

#define VIC_VME_INT_REG1  0X7FD90004
#define VIC_VME_INT_REG2  0X7FD90008
#define VIC_VME_INT_REG3  0X7FD9000C
#define VIC_VME_INT_REG4  0X7FD90010
#define VIC_VME_INT_REG5  0X7FD90014
#define VIC_VME_INT_REG6  0X7FD90018
#define VIC_VME_INT_REG7  0X7FD9001C

#define VIC_DMA_INT_REG   0X7FD90020

#define VIC_LOC_INT_REG1  0X7FD90024
#define VIC_LOC_INT_REG2  0X7FD90028
#define VIC_LOC_INT_REG3  0X7FD9002C
#define VIC_LOC_INT_REG4  0X7FD90030
#define VIC_LOC_INT_REG5  0X7FD90034
#define VIC_LOC_INT_REG6  0X7FD90038
#define VIC_LOC_INT_REG7  0X7FD9003C

#define VIC_ICGS_INT_CONT 0X7FD90040
#define VIC_ICMS_INT_CONT 0X7FD90044

#define VIC_ERR_INT_CONT  0X7FD90048

#define VIC_ICGS_INT_VECT 0X7FD9004C
#define VIC_ICMS_INT_VECT 0X7FD90050
#define VIC_LOC_INT_VECT  0X7FD90054
#define VIC_ERR_INT_VECT  0X7FD90058

#define VIC_ICS_REG       0X7FD9005C

#define VIC_ICS_REG0      0X7FD90060
#define VIC_ICS_REG1      0X7FD90064
#define VIC_ICS_REG2      0X7FD90068
#define VIC_ICS_REG3      0X7FD9006C
#define VIC_ICS_REG4      0X7FD90070
#define VIC_ICS_REG5      0X7FD90074
#define VIC_ICS_REG6      0X7FD90078
#define VIC_ICS_REG7      0X7FD9007C

#define VIC_VME_INT_STAT  0X7FD90080

#define VIC_VME_INT_VEC1  0X7FD90084
#define VIC_VME_INT_VEC2  0X7FD90088
#define VIC_VME_INT_VEC3  0X7FD9008C
#define VIC_VME_INT_VEC4  0X7FD90090
#define VIC_VME_INT_VEC5  0X7FD90094
#define VIC_VME_INT_VEC6  0X7FD90098
#define VIC_VME_INT_VEC7  0X7FD9009C

#define VIC_LOC_TIME_REG  0X7FD900A0
#define VIC_LOC_TIMER_REG 0X7FD900A4

#define VIC_BLT_REG       0X7FD900A8
#define VIC_VME_CONFIG    0X7FD900AC

#define VIC_REQUEST_REG   0X7FD900B0
#define VIC_VME_ARB_REQ   0X7FD900B0

#define VIC_VME_AM_REG    0X7FD900B4
#define VIC_BUS_ERR_STAT  0X7FD900B8
#define VIC_DMA_STAT      0X7FD900BC

#define VIC_SLAVE0_CON0   0X7FD900C0
#define VIC_SLAVE0_CON1   0X7FD900C4
#define VIC_SLAVE1_CON0   0X7FD900C8
#define VIC_SLAVE1_CON1   0X7FD900CC

#define VIC_RELEASE_REG   0X7FD900D0

#define VIC_BLT_CON_REG   0X7FD900D4
#define VIC_BLT_LEN_REG0  0X7FD900D8
#define VIC_BLT_LEN_REG1  0X7FD900DC

#define VIC_RESET_REG     0X7FD900E0
/*}}}*/
/*{{{board*/
#define SPLAT_BERR        0X7FD98000
#define SPLAT_EV          0X7FD98004
#define ENABLE_VPP        0X7FD98008

#define VIC_IRQ_VECTOR    0X7FDA0004

#define ENABLE_VME_SLAVE  0X7FDC0040
#define ENABLE_BYTE_MUX   0X7FDC0044
#define NEXT_MAP_RAM      0X7FDC0048
#define NEXT_DECODE_RAM   0X7FDC004C
#define HIDE_REGS         0X7FDC0050
#define ENABLE_VME_MASTER 0X7FDC0054
#define ROM_BASE_ADDRESS  0X7FE00000
/*}}}*/
/*{{{mux*/
#define MUX_PAGE0_0       0X7FDC0080
#define MUX_PAGE0_1       0X7FDC0084
#define MUX_PAGE0_2       0X7FDC0088
#define MUX_PAGE0_3       0X7FDC008C
#define MUX_PAGE1_0       0X7FDC0090
#define MUX_PAGE1_1       0X7FDC0094
#define MUX_PAGE1_2       0X7FDC0098
#define MUX_PAGE1_3       0X7FDC009C
#define MUX_PAGE2_0       0X7FDC00A0
#define MUX_PAGE2_1       0X7FDC00A4
#define MUX_PAGE2_2       0X7FDC00A8
#define MUX_PAGE2_3       0X7FDC00AC

#define MUX_PAGE3_0       0X7FDC00B0
#define MUX_PAGE3_1       0X7FDC00B4
#define MUX_PAGE3_2       0X7FDC00B8
#define MUX_PAGE3_3       0X7FDC00BC

#define MUX_PAGE4_0       0X7FDC00C0
#define MUX_PAGE4_1       0X7FDC00C4
#define MUX_PAGE4_2       0X7FDC00C8
#define MUX_PAGE4_3       0X7FDC00CC

#define MUX_PAGE5_0       0X7FDC00D0
#define MUX_PAGE5_1       0X7FDC00D4
#define MUX_PAGE5_2       0X7FDC00D8
#define MUX_PAGE5_3       0X7FDC00DC

#define MUX_PAGE6_0       0X7FDC00E0
#define MUX_PAGE6_1       0X7FDC00E4
#define MUX_PAGE6_2       0X7FDC00E8
#define MUX_PAGE6_3       0X7FDC00EC

#define MUX_PAGE7_0       0X7FDC00F0
#define MUX_PAGE7_1       0X7FDC00F4
#define MUX_PAGE7_2       0X7FDC00F8
#define MUX_PAGE7_3       0X7FDC00FC



/*}}}*/
/*{{{mapram*/
#define MASTER_PERMIT 0x8000
#define AM_UDATA 0x0000
#define AM_UPROG 0x2000
#define AM_SDATA 0x4000
#define AM_SPROG 0x6000
#define ASIZ_AMSOURCE 0x0000
#define ASIZ_32BIT 0x0080
#define ASIZ_16BIT 0x0100
#define ASIZ_24BIT 0x0180
#define LADD00 0x0000
#define LADD01 0x0800
#define LADD10 0x1000
#define LADD11 0x1800
#define DSIZ_32BIT 0x0000
#define DSIZ_8BIT 0x0200
#define DSIZ_16BIT 0x0400
#define DSIZ_THREE 0x0600
/*}}}*/

/* Subsystem definitions */
#define TX_RESET_REG   0x0
#define TX_ANALYSE_REG 0x4
#define TX_ERROR_REG   0x0

/* prototypes for basic routines */

extern void shadow_write_map_ram(void *address, int data);
extern int shadow_read_map_ram(void *address);
extern void clear_map_ram(void);
extern void write_decode_ram(void *address,int val);
extern void clear_decode_ram(void) ;
extern int check_board_init(void) ;
extern void basic_board_init(void);
extern void turnon_byte_mux(void);
extern void turnoff_byte_mux(void);
extern void program_byte_mux(int which_page,int read_swap,int write_swap);
extern void set_mux_0_transparent(void);
extern void program_mux_map_ram(int which_swap,void *address);

#define uint unsigned int
