/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : event.h
              Author : S.R.Christian, D. Johnston
   Date first issued : 12-Apr-91

Definitions to support event handling

Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
******************************************************************/
/*}}}*/

#define VECTOR_PEX         11
#define VECTOR_DUART       12
#define VECTOR_BERR         9
#define VECTOR_RTC         10

#define VECTOR_ACFAIL      16
#define VECTOR_WRITEPOST   17
#define VECTOR_ARBTIME     18
#define VECTOR_SYSFAIL     19
#define VECTOR_INTACK      20

#define VECTOR_ICMS0       4
#define VECTOR_ICMS1       5
#define VECTOR_ICMS2       6
#define VECTOR_ICMS3       7

#define VECTOR_ICGS0      24
#define VECTOR_ICGS1      25
#define VECTOR_ICGS2      26
#define VECTOR_ICGS3      27

#define VECTOR_INT_1      28
#define VECTOR_INT_2      29
#define VECTOR_INT_3      30
#define VECTOR_INT_4      31
#define VECTOR_INT_5      32
#define VECTOR_INT_6      33
#define VECTOR_INT_7      34

/* protypes for event handing functions */

extern int berr_happened;    /* public flag value */

extern int start_event_handler(void);

extern int give_next_vector(int vector, void (*routine)());
extern int ask_to_use_vector(int vector, void (*routine)());

extern void standard_berr_handler(void);
extern int install_berr_handler(void (*routine)());
extern int install_vme_int_handler(int level,int vector,void (*routine)());
extern int install_vme_int_ack_handler(void (*routine)());
extern int install_duart_int_handler(void (*routine)());

