/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : rom.h
              Author : S.R.Christian, D. Johnston
   Date first issued : 12-Apr-91

Definitions to support Flash ROM devices on IMS B016


Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
******************************************************************/
/*}}}*/

#define SETUP_PROG 0x40
#define PROG       0x40
#define SETUP_ERASE 0x20
#define ERASE       0x20
#define PROG_VERIFY 0xc0
#define ERASE_VERIFY 0xa0
#define RESET        0xff
#define READ_MANF_CODE 0x80

/* protypes for rom support functions */

extern void reset_rom(void);
extern int blank_check_rom(void);
extern void write_rom(int,int,int);
extern int find_rom_size(void);
extern int read_rom(int,int);
extern void turnon_vpp(void);
extern void turnoff_vpp(void);
extern int read_rom_device_code(int);
extern int read_rom_manf_code(int);
extern void rom_read_mode(int);
extern int program_wait_verify(int,int,int);
extern int program_byte(int,int,int);
extern void erase_wait(int);
extern int erase_verify(int,int);
extern int erase_rom(int);

