/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : rtc.h
              Author : S.R.Christian, D. Johnston
   Date first issued : 12-Apr-91

Definitions to support the Real Time Clock on the IMS B016

Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
******************************************************************/
/*}}}*/

#define RTC_MAIN_STATUS            0X7FD88000
#define RTC_NVRAM                  0X7FD88000

#define RTC_REAL_TIME_MODE         0X7FD88004
#define RTC_OUTPUT_MODE            0X7FD88008
#define RTC_INTERRUPT_CONTROL_0    0X7FD8800C
#define RTC_PERIODIC_FLAG          0X7FD8800C

#define RTC_INTERRUPT_CONTROL_1    0X7FD88010
#define RTC_TIME_SAVE_CONTROL      0X7FD88010

#define RTC_100_SECOND_COUNTER     0X7FD88014
#define RTC_SECONDS_COUNTER        0X7FD88018
#define RTC_MINUTES_COUNTER        0X7FD8801C
#define RTC_HOURS_COUNTER          0X7FD88020
#define RTC_DAY_OF_MONTH_COUNTER   0X7FD88024
#define RTC_MONTHS_COUNTER         0X7FD88028
#define RTC_YEARS_COUNTER          0X7FD8802C
#define RTC_UNITS_JULIAN_COUNTER   0X7FD88030
#define RTC_100_JULIAN_COUNTER     0X7FD88034
#define RTC_DAY_OF_WEEK_COUNTER    0X7FD88038
#define RTC_SECONDS_COMPARE        0X7FD8804C
#define RTC_MINUTES_COMPARE        0X7FD88050
#define RTC_HOURS_COMPARE          0X7FD88054
#define RTC_DAY_OF_MONTH_COMPARE   0X7FD88058
#define RTC_MONTHS_COMPARE         0X7FD8805C
#define RTC_DAY_OF_WEEK_COMPARE    0X7FD88060
#define RTC_SECONDS_TIME_SAVE      0X7FD88064
#define RTC_MINUTES_TIME_SAVE      0X7FD88068
#define RTC_HOURS_TIME_SAVE        0X7FD8806C
#define RTC_DAY_OF_MONTH_TIME_SAVE 0X7FD88070
#define RTC_MONTHS_TIME_SAVE       0X7FD88074
#define RTS_RAM                    0X7FD88078
#define RTS_RAMTEST                0X7FD8807C

/* protypes for the rtc support functions */

extern int rtc_get(struct tm *broken_time);
extern int rtc_set(struct tm *broken_time);
extern time_t rtc_settimeofday(time_t *time);
extern time_t rtc_gettimeofday(time_t *time);


