/*{{{ COMMENT Standard Header*/
/******************************************************************
COPYRIGHT (C) INMOS LIMITED - 1990, 1991

    Source file name : vme.h
              Author : S.R.Christian, D. Johnston
   Date first issued : 12-Apr-91



Date        Modification                                    Initials
----        ------------                                    --------
02-Oct-91   Adapted from original                           SRC
18-Oct-91   changed external definitions                    SRC
******************************************************************/
/*}}}*/

#define WRITEPOST 1
#define NO_WRITEPOST 0
#define RELMODE_ROR 0
#define RELMODE_RWD 1
#define RELMODE_ROC 2
#define RELMODE_BCAP 3

#define ARBITER_PRI 1
#define ARBITER_RRS 2

#define VMETIMEOUT_4US 0
#define VMETIMEOUT_16US 1
#define VMETIMEOUT_32US 2
#define VMETIMEOUT_64US 3
#define VMETIMEOUT_128US 4
#define VMETIMEOUT_256US 5
#define VMETIMEOUT_512US 6
#define VMETIMEOUT_INF 7


/* prototypes for vme functions */

extern int prog_slave_access(void *decode_address,
                             int decode_window,
                             int address_type,
                             int writepost);

extern int init_slot_one(int arbitration_style,
                         int bus_timeout);

extern int init_vme_master(int request_level,
                           int request_mode,
                           int writepost);

extern int turnon_vme_master(void);

extern int turnoff_vme_master(void);

extern int prog_master_access(void *address,
                                  int address_window,
                                  int data_type,
                                  int address_type,
                                  int lower_address,
                                  int mux_fn);

extern int send_vme_interrupt(int int_level);

extern int prog_vme_interrupt_vector(int int_level,
                                     int vector);

