LIBRARIAN=ilibr
OCCAM=oc
LINK=ilink
CONFIG=icconf
OCONFIG=occonf
COLLECT=icollect
CC=icc
DELETE=rm
LIBOPT=
OCCOPT=
LINKOPT=
CONFOPT= -RO -RS 256k -P root
OCONFOPT=
COLLECTOPT= -RO -RS 256k
COPT= -D UNHOSTED

boardmon.bin: boardmon.btl boardmon.epr
	ieprom boardmon.epr -i

##### IMAKEF CUT #####

boardmon.btl: boardmon.cfb 
	$(COLLECT) boardmon.cfb -o boardmon.btl $(COLLECTOPT)

boardmon.cfb: boardmon.cfs boardmon.c9x 
	$(CONFIG) boardmon.cfs -o boardmon.cfb $(CONFOPT)

boardmon.c9x: boardmon.lnk ../libs/duart.t9h ../libs/event.t9h \
              ../libs/basic.t9h ../libs/rtc.t9h ../libs/vme.t9h \
              ../libs/rom.t9h ../cli/clilib.t9h boardmon.t9h \
              /inmos/prod/d4214b/libs/startrd.lnk \
              /inmos/prod/d4214b/libs/centry.lib \
              /inmos/prod/d4214b/libs/libcred.lib 
	$(LINK) -f boardmon.lnk -t9 -x -o boardmon.c9x $(LINKOPT)

../libs/duart.t9h: ../libs/duart.c /inmos/prod/d4214b/libs/stdlib.h \
                   /inmos/prod/d4214b/libs/process.h \
                   /inmos/prod/d4214b/libs/channel.h \
                   /inmos/prod/d4214b/libs/subchan.h \
                   /inmos/prod/d4214b/libs/misc.h \
                   /inmos/prod/d4214b/libs/subsem.h ../include/basic.h \
                   ../include/duart.h ../include/event.h 
	$(CC) ../libs/duart.c -t9 -o ../libs/duart.t9h $(COPT)

../libs/event.t9h: ../libs/event.c /inmos/prod/d4214b/libs/stdlib.h \
                   /inmos/prod/d4214b/libs/process.h \
                   /inmos/prod/d4214b/libs/channel.h \
                   /inmos/prod/d4214b/libs/subchan.h \
                   /inmos/prod/d4214b/libs/misc.h \
                   /inmos/prod/d4214b/libs/subsem.h ../include/basic.h \
                   ../include/event.h 
	$(CC) ../libs/event.c -t9 -o ../libs/event.t9h $(COPT)

../libs/basic.t9h: ../libs/basic.c ../include/basic.h 
	$(CC) ../libs/basic.c -t9 -o ../libs/basic.t9h $(COPT)

../libs/rtc.t9h: ../libs/rtc.c /inmos/prod/d4214b/libs/time.h ../include/rtc.h \
                 ../include/basic.h 
	$(CC) ../libs/rtc.c -t9 -o ../libs/rtc.t9h $(COPT)

../libs/vme.t9h: ../libs/vme.c ../include/basic.h ../include/vme.h 
	$(CC) ../libs/vme.c -t9 -o ../libs/vme.t9h $(COPT)

../libs/rom.t9h: ../libs/rom.c ../include/basic.h ../include/rom.h \
                 /inmos/prod/d4214b/libs/channel.h \
                 /inmos/prod/d4214b/libs/subchan.h \
                 /inmos/prod/d4214b/libs/process.h 
	$(CC) ../libs/rom.c -t9 -o ../libs/rom.t9h $(COPT)

../cli/clilib.t9h: ../cli/clilib.c /inmos/prod/d4214b/libs/stdiored.h \
                   /inmos/prod/d4214b/libs/subsem.h \
                   /inmos/prod/d4214b/libs/subchan.h \
                   /inmos/prod/d4214b/libs/stdio.h \
                   /inmos/prod/d4214b/libs/stdlib.h \
                   /inmos/prod/d4214b/libs/string.h \
                   /inmos/prod/d4214b/libs/stdarg.h \
                   /inmos/prod/d4214b/libs/ctype.h ../include/clilib.h 
	$(CC) ../cli/clilib.c -t9 -o ../cli/clilib.t9h $(COPT)

boardmon.t9h: boardmon.c /inmos/prod/d4214b/libs/stdiored.h \
              /inmos/prod/d4214b/libs/subsem.h \
              /inmos/prod/d4214b/libs/subchan.h \
              /inmos/prod/d4214b/libs/stdlib.h /inmos/prod/d4214b/libs/ctype.h \
              /inmos/prod/d4214b/libs/string.h \
              /inmos/prod/d4214b/libs/iocntrl.h /inmos/prod/d4214b/libs/misc.h \
              /inmos/prod/d4214b/libs/process.h \
              /inmos/prod/d4214b/libs/channel.h /inmos/prod/d4214b/libs/time.h \
              ../include/vme.h ../include/duart.h ../include/event.h \
              ../include/basic.h ../include/rtc.h ../include/rom.h \
              ../include/clilib.h moncoms.c 
	$(CC) boardmon.c -t9 -o boardmon.t9h $(COPT)

