/* %W%	%E%
/*#############################################################################
 *
 *	Copyright (C) 1989 K-par Systems  Ltd.  All rights reserved
 *
 * Program/Library:	b008 - Sun 386i B008 driver - ims_b008cmd.h
 *
 * Purpose: 		b008 driver user definitions file
 *
 * Author:		Chris Farey 28-Sep-1989
 *
 *---------------------------------------------------------------------------*/

#ifndef _IMS_B008CMD_H

#define _IMS_B008CMD_H

#include <sys/ioccom.h>

/*
 * I/O controls
 */
struct B008_SETF 
{
    unsigned int op:16;   
    unsigned int val:16;
};

struct B008_READF 
{
    unsigned int reserved:28;
    unsigned int read_f:1;
    unsigned int write_f:1;
    unsigned int timeout_f:1;			/* not used */
    unsigned int error_f:1;
};

union B008_IO 
{
    struct B008_SETF set;
    struct B008_READF status;
};

#define RESET			(1)
#define ANALYSE			(2)
#define SETTIMEOUT		(3)
#define SETERRORSIGNAL		(4)
#define RESETERRORSIGNAL	(5)
#define SETREADDMA		(6)		/* use DMA for reads */
#define	SETWRITEDMA		(7)		/* use DMA for writes */
#define	RESETDMA		(8)		/* turn off DMA */

/*
 * _IOR and _IOW encode the read/write instructions to the kernel within the
 * ioctl command code.
 */

#define READFLAGS	_IOR(k, 0, union B008_IO)
#define SETFLAGS	_IOW(k, 1, union B008_IO)

#endif
