#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <channel.h>
#include <misc.h>

#include "facs.h"

static Channel *Checked_ChanAlloc() {
  Channel *chan;

  if ((chan = ChanAlloc()) == NULL) {
    fprintf(stderr, "ChanAlloc () failed\n");
    exit(EXIT_FAILURE);
  }
  return chan;
}

int main(int argc, char **argv) {
  Channel *square_to_sum;
  Channel *sum_to_control; 
  Channel *feed_to_facs;
  Channel *control_to_feed;
  Channel *end[2];
  Process *p_feed, *p_sum, *p_control;
  int i;

  square_to_sum   = get_param(3);
  feed_to_facs    = get_param(4);
  sum_to_control  = Checked_ChanAlloc();
  control_to_feed = Checked_ChanAlloc();

  for (i = 0; i < 2; i++)
    end[i] = Checked_ChanAlloc();

  printf("PRE: ProcAlloc\n");
  if ((p_feed = ProcAlloc(feed, 0, 3, control_to_feed, feed_to_facs, end[0])) &&
      (p_sum = ProcAlloc(sum, 0, 3, square_to_sum, sum_to_control, end[1])) &&
      (p_control = ProcAlloc(control, 0, 3, sum_to_control, control_to_feed, end))) {

    ProcPar(p_feed, p_sum, p_control, NULL);

    printf("Have finished one run\n");
    printf("Trying another one\n");

    ProcPar(p_feed, p_control, p_sum, 0);

    printf("All done\n");

  } else {
    fprintf(stderr, "ProcAlloc () failed\n");
    exit_terminate(EXIT_FAILURE);
  }
  exit_terminate(EXIT_SUCCESS);
}
