#include <stdlib.h>
#include <process.h>
#include <channel.h>
#include <misc.h>
#include <math.h>
#include "matrix.h"

static Channel * in, *out;

int GenerateRandomNumber(int max)
{
 return (rand()%max);
 
}

void MatrixMul(Matrix matrix1,Matrix matrix2,Matrix result)
{
 int row,col,x;
 double sum;

 for(row=0;row<MATRIX_SIZE;row++) {
     for(col=0;col<MATRIX_SIZE;col++) {
         sum=0.0;
         for(x=0;x<MATRIX_SIZE;x++) {
             sum+=matrix1[row][x]*matrix2[x][col];
         }
         result[row][col]=sum;
     }     
 }

}



void GenerateRandomMatrix(Matrix matrix,double mult)
{
 int row,col;

 for(row=0;row<MATRIX_SIZE;row++) {
     for(col=0;col<MATRIX_SIZE;col++) {
         matrix[row][col]=( ((double) rand()) / (double) RAND_MAX ) * mult;
      }
 }
 
}


void Soaker(Process *p,Channel *start)
{
 int end;

 p=p;
 for(;;) { 
    /* Get sync */
    if(ChanInInt(start)==1) break;
    ProcWait(64*777); /* Do nothing for  bit */
    end = ProcTimePlus(ProcTime(),666*64);
    while(ProcTimeAfter(end,ProcTime())); /* Sit in busy loop */
 }
}

#define NUMBER_MATRIX_MUL 25

main(void)
{
 Matrix m1,m2,result;
 int end;
 int pos;
 int x;
 Channel * sync;
 Process *p;
 

 in  = (Channel *) get_param(1);
 out = (Channel *) get_param(2);
 end = *(int *) get_param(3);
 pos= *(int *) get_param(4);

 /* These should both be checked in a real program */ 
 sync=ChanAlloc();
 p=ProcAlloc(Soaker,0,1,sync);

 ProcRunHigh(p);
 
 GenerateRandomMatrix(m2,10.0);

 for(;;) {
    ChanIn(in,m1,sizeof(Matrix));
    for(x=0;x<NUMBER_MATRIX_MUL;x++) {
        MatrixMul(m1,m2,result);
    }
    ChanOut(out,m1,sizeof(Matrix));
    ChanOutInt(sync,0); /* Signal high thread */
 }

}

     
     
