/*------------------------------------------------------------------------------
--
-- File    : metsetup.h
--   metalinkio setup module
--
-- Copyright 1992 INMOS Limited
--
-- Date    : 6/2/92
-- Version : 1.2
-- 
-- 29/06/92 - dave edwards; based on parts of metlnkio.c, lmethod.h
--
------------------------------------------------------------------------------*/

typedef int (*t_IOFnptr) ();

/****
 **** number of supported methods
****/
#define MS_MAXLMETHODS 14

/****
 **** refs. for internal state variables
****/
extern int       ms_Maxmethodval;
extern int       ms_Available[];
extern t_IOFnptr ms_Openlink[];
extern t_IOFnptr ms_Closelink[];
extern t_IOFnptr ms_Readlink[];
extern t_IOFnptr ms_Writelink[];
extern t_IOFnptr ms_Resetlink[];
extern t_IOFnptr ms_Analyselink[];
extern t_IOFnptr ms_TestError[];
extern char      *ms_Methodnames[];



/****
 **** lmethod constants. must be same as values defined in metsetup.h re. strings
****/
#define HW_X      0
#define B004      1
#define B008      2 
#define B010      3
#define B011      4
#define B014      5
#define DRX11     6
#define QT0       7
#define B015      8
#define IBM_CAT   9
#define B016      10
#define UDP       11     
#define TCP_LINKOPS 12
#define B017      13  


void ms_Init ();


